package ControlFlow

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_break_continue.htm
 */
class BreakStatements {
	/**
	 * How to use break to end a single loop
	 */
	fun breakSingleLoop() {
		var i = 0
		while (i++ < 100) {
			println(i)
			if (i == 3) {
				break
			}
		}
	}

	/**
	 * How to use break to break a specific loop
	 */
	fun annotatedBreak() {
		outerLoop@ for (i in 1..3) {
			innerLoop@ for (j in 1..3) {
				println("i = $i and j = $j")
				if (i == 2) {
					break@outerLoop
				}
			}
		}
	}

	/**
	 * How to use continue to skip to the next iteration of a single loop
	 */
	fun continueSingleLoop() {
		var i = 0
		while (i++ < 6) {
			if (i == 3) {
				continue
			}
			println(i)
		}
	}

	/**
	 * How to use continue to skip to the next iteration of a specific loop
	 */
	fun annotatedContinue() {
		outerLoop@ for (i in 1..3) {
			innerLoop@ for (j in 1..3) {
				if (i == 2) {
					continue@outerLoop
				}
				println("i = $i and j = $j")
			}
		}
	}
}
