package ControlFlow

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_for_loop.htm
 */
class ForStatements {
	/**
	 * Normal for loop given a range to iterate over.
	 * Both borders are included
	 */
	fun forItemInRange() {
		for (item in 1..5) {
			println(item)
		}
		// 1 2 3 4 5
	}

	/**
	 * Iterates over the given range with the given step size.
	 * Both borders are included
	 */
	fun forItemInRangeSteps() {
		for (item in 5 downTo 1 step 2) {
			println(item)
		}
		// 5 3 1
	}

	/**
	 * How to iterate over each item in a list
	 */
	fun forItemInList() {
		var fruits = arrayOf("Orange", "Apple", "Mango", "Banana")
		for (item in fruits) {
			println(item)
		}
	}

	/**
	 * How to iterate over a list using the list indices
	 */
	fun iterateOverIndices() {
		var fruits = arrayOf("Orange", "Apple", "Mango", "Banana")
		for (index in fruits.indices) {
			println(fruits[index])
		}
	}
}
