package ControlFlow

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_if_else_expression.htm
 */
class IfStatements {
	/**
	 * How to return a value from an if statement
	 */
	fun ifWithReturnValue() {
		val age: Int = 10
		val result = if (age > 18) {
			"Adult"
		} else {
			"Minor"
		}
		println(result)
	}

	/**
	 * Like the tertiary operator in java
	 */
	fun ifWithReturnTertiary() {
		val age: Int = 10
		val result = if (age > 18) "Adult" else "Minor"
		println(result)
	}

	/**
	 * Returns a value from the if statement and also does stuff
	 */
	fun ifWithReturnValueAndDoesStuff() {
		val age: Int = 10
		val result = if (age > 18) {
			println("Given condition is true")
			"Adult"
		} else {
			println("Given condition is false")
			"Minor"
		}
		print("The value of result : ")
		println(result)
	}

	/**
	 * Nested if with return value
	 */
	fun nestedIfWithReturn() {
		val age: Int = 20
		val result = if (age > 12) {
			if (age > 12 && age < 20) {
				"Teen"
			} else {
				"Adult"
			}
		} else {
			"Minor"
		}
		print("The value of result : ")
		println(result)
	}
}
